Given an array of citations sorted in ascending order (each citation is a non-negative integer) of a researcher, write a function to compute the researcher's h-index.
According to the definition of h-index on Wikipedia: "A scientist has index h if h of his/her N papers have at least h citations each, and the other N − h papers have no more than h citations each."
Example:
Input: citations = [0,1,3,5,6] Output: 3 Explanation: [0,1,3,5,6] means the researcher has 5 papers in total and each of them had received 0, 1, 3, 5, 6 citations respectively. Since the researcher has 3 papers with at least 3 citations each and the remaining two with no more than 3 citations each, her h-index is 3.
Note:
If there are several possible values for h, the maximum one is taken as the h-index.
Follow up:
- This is a follow up problem to H-Index, where
citations
is now guaranteed to be sorted in ascending order. - Could you solve it in logarithmic time complexity?
本题是LeetCode 274. H-Index —— H指数升级版。把上道题code直接拿过来去掉排序就是答案,O(n)级别。本题要求对数级别时间复杂度,自然想到二分查找。如果找到的文章的引用数大于引用数大于等于该引用数的文章数,那么在左区间查找,反之在右区间。如果大于等于改引用数的文章数恰好等于该引用数,那就直接返回这个文章数。这里有一个问题,就是如果找不到一个引用数恰好等于引用数大于该引用数的文章数怎么办,比如{0, 0, 0, 5, 5}。对于search miss的情况,典型的二分查找写法lo指针会停到hi指针右侧,而lo和hi一定是分列search key的两侧。一定注意本题的search key其实是文章数而不是引用数,即对于{0, 0, 0, 5, 5}这个例子我们要找到的是数字2,代表有两篇文章,这两篇文章的引用数至少是2,而引用数2并不属于任何一篇文章,即不在数组里。所以当这个例子search miss后,hi会停在第三篇文章处,即hi = 2,而lo一定在它的右侧,即lo = 3。既然我们找的是文章数,且文章数的引用数至少是这个文章数,那么对于search miss,“至少”这个概念对于lo,即文章数较小(因为是n - (search key)),更易实现,所以应该返回更靠右的指针,即lo。
Java
class Solution { public int hIndex(int[] citations) { if (citations == null || citations.length == 0) return 0; int n = citations.length, lo = 0, hi = n - 1; while (lo <= hi) { int mid = lo + (hi - lo) / 2; if (citations[mid] > n - mid) hi = mid - 1; else if (citations[mid] < n - mid) lo = mid + 1; else return n - mid; } return n - lo; } }